"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _mailgun = _interopRequireDefault(require("mailgun.js"));
var _formData = _interopRequireDefault(require("form-data"));
var _config = _interopRequireDefault(require("config"));
var _fs = _interopRequireDefault(require("fs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
const mailgun = new _mailgun.default(_formData.default);
const defaultUrl = _config.default.has("mailgun.host") ? _config.default.get("mailgun.host") : undefined;
const defaultMg = mailgun.client({
  username: "api",
  key: _config.default.get("mailgun.api_key"),
  url: defaultUrl
});
const defaultDomain = _config.default.get("mailgun.domain");
const pathnamesToReadStream = pathnames => {
  return pathnames ? Array.isArray(pathnames) ? pathnames.map(f => _fs.default.createReadStream(f)) : _fs.default.createReadStream(pathnames) : undefined;
};

// TODO faire autant de factoryMailgun que de channel puis utiliser la bonne en dessous ;)

// TODO get info mailgun from constant by channel
const sendMail = (data, mailgunConfig, logger, fn) => {
  const mg = mailgunConfig ? mailgun.client({
    username: "api",
    key: mailgunConfig.apiKey,
    url: mailgunConfig.host ? "https://" + mailgunConfig.host : undefined
  }) : defaultMg;
  const domain = mailgunConfig ? mailgunConfig.domain : defaultDomain;
  return new Promise((resolve, reject) => {
    const _data = {
      ...data,
      inline: pathnamesToReadStream(data.inline)
    };
    mg.messages.create(domain, _data).then(body => {
      if (fn) fn(body);
      return resolve();
    }).catch(error => {
      if (logger) {
        logger.error(JSON.stringify(error));
        logger.error(error.message);
      }
      return reject(new Error(`An error occured while sending email: ${error.message},__JSON__:${JSON.stringify(_data)}`));
    });
  });
};
var _default = sendMail;
exports.default = _default;