"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
const BAD_REQUEST = message => {
  return {
    error: {
      code: 400,
      message
    }
  };
};
const errorMessage = validation => {
  return validation.error.details.map(detail => detail.message).join(", ");
};
const validate = (data, schema) => {
  const validation = schema.validate(data);
  return !validation.error ? validation.value : BAD_REQUEST(errorMessage(validation));
};
var _default = validate;
exports.default = _default;